package com.ccnode.codegenerator.mybatisGenerator.plugins;

package .tmp;

import com.ccnode.codegenerator.mybatisGenerator.plugins.tools.FormatTools;
import com.ccnode.codegenerator.mybatisGenerator.plugins.tools.JavaElementGeneratorTools;
import java.util.List;
import java.util.Objects;
import org.apache.commons.lang3.StringEscapeUtils;
import org.mybatis.generator.api.IntrospectedColumn;
import org.mybatis.generator.api.IntrospectedTable;
import org.mybatis.generator.api.PluginAdapter;
import org.mybatis.generator.api.dom.java.FullyQualifiedJavaType;
import org.mybatis.generator.api.dom.java.Interface;
import org.mybatis.generator.api.dom.java.JavaVisibility;
import org.mybatis.generator.api.dom.java.Method;
import org.mybatis.generator.api.dom.java.Parameter;
import org.mybatis.generator.api.dom.java.TopLevelClass;
import org.mybatis.generator.api.dom.xml.Attribute;
import org.mybatis.generator.api.dom.xml.Document;
import org.mybatis.generator.api.dom.xml.Element;
import org.mybatis.generator.api.dom.xml.TextElement;
import org.mybatis.generator.api.dom.xml.XmlElement;
import org.mybatis.generator.codegen.mybatis3.MyBatis3FormattingUtilities;

public class UpdateBatchPlugin extends PluginAdapter {
  private FullyQualifiedJavaType a = new FullyQualifiedJavaType("java.util.List");
  
  public boolean validate(List<String> paramList) {
    return true;
  }
  
  public boolean sqlMapDocumentGenerated(Document paramDocument, IntrospectedTable paramIntrospectedTable) {
    if (paramIntrospectedTable.hasPrimaryKeyColumns()) {
      XmlElement xmlElement1 = paramDocument.getRootElement();
      XmlElement xmlElement2 = new XmlElement("update");
      xmlElement2.getAttributes().add(0, new Attribute("id", "updateBatch"));
      xmlElement2.getAttributes().add(new Attribute("parameterType", "java.util.List"));
      getContext().getCommentGenerator().addComment(xmlElement2);
      TextElement textElement = new TextElement("update " + paramIntrospectedTable.getFullyQualifiedTableNameAtRuntime());
      XmlElement xmlElement3 = new XmlElement("trim");
      xmlElement3.addAttribute(new Attribute("prefix", "set"));
      xmlElement3.addAttribute(new Attribute("suffixOverrides", ","));
      List<IntrospectedColumn> list = paramIntrospectedTable.getPrimaryKeyColumns();
      if (list.size() == 1) {
        String str = b(paramIntrospectedTable.getPrimaryKeyColumns().get(0), false);
        List list1 = paramIntrospectedTable.getNonPrimaryKeyColumns();
        Objects.requireNonNull(xmlElement3);
        list1.stream().map(paramIntrospectedColumn -> {
              XmlElement xmlElement1 = new XmlElement("trim");
              xmlElement1.addAttribute(new Attribute("prefix", StringEscapeUtils.escapeXml11(MyBatis3FormattingUtilities.getEscapedColumnName(paramIntrospectedColumn)) + " = case"));
              xmlElement1.addAttribute(new Attribute("suffix", "end,"));
              XmlElement xmlElement2 = new XmlElement("foreach");
              xmlElement2.getAttributes().add(0, new Attribute("collection", "list"));
              xmlElement2.getAttributes().add(1, new Attribute("item", "item"));
              xmlElement2.getAttributes().add(2, new Attribute("index", "index"));
              String str = "when " + MyBatis3FormattingUtilities.getEscapedColumnName(paramIntrospectedTable.getPrimaryKeyColumns().get(0)) + " = " + paramString + " then " + b(paramIntrospectedColumn, false);
              TextElement textElement = new TextElement(str);
              xmlElement2.addElement((Element)textElement);
              xmlElement1.addElement(0, (Element)xmlElement2);
              return xmlElement1;
            }).forEachOrdered(xmlElement3::addElement);
        TextElement textElement1 = new TextElement("where " + MyBatis3FormattingUtilities.getEscapedColumnName(paramIntrospectedTable.getPrimaryKeyColumns().get(0)) + " in");
        XmlElement xmlElement = new XmlElement("foreach");
        xmlElement.getAttributes().add(0, new Attribute("collection", "list"));
        xmlElement.getAttributes().add(1, new Attribute("item", "item"));
        xmlElement.getAttributes().add(1, new Attribute("open", "("));
        xmlElement.getAttributes().add(2, new Attribute("separator", ", "));
        xmlElement.getAttributes().add(1, new Attribute("close", ")"));
        xmlElement.addElement((Element)new TextElement(str));
        xmlElement2.addElement((Element)textElement);
        xmlElement2.addElement((Element)xmlElement3);
        xmlElement2.addElement((Element)textElement1);
        xmlElement2.addElement((Element)xmlElement);
      } else {
        List list1 = paramIntrospectedTable.getPrimaryKeyColumns();
        String str1 = "concat(";
        for (byte b1 = 0; b1 < list.size(); b1++) {
          if (b1 != list.size() - 1) {
            str1 = str1 + str1 + ",'_',";
          } else {
            str1 = str1 + str1 + ")";
          } 
        } 
        List list2 = paramIntrospectedTable.getNonPrimaryKeyColumns();
        String str2 = "concat(";
        for (byte b2 = 0; b2 < list.size(); b2++) {
          IntrospectedColumn introspectedColumn = list.get(b2);
          if (b2 != list.size() - 1) {
            str2 = str2 + str2 + ",'_',";
          } else {
            str2 = str2 + str2 + ")";
          } 
        } 
        String str3 = str2;
        String str4 = str1;
        Objects.requireNonNull(xmlElement3);
        list2.stream().map(paramIntrospectedColumn -> {
              XmlElement xmlElement1 = new XmlElement("trim");
              xmlElement1.addAttribute(new Attribute("prefix", StringEscapeUtils.escapeXml11(MyBatis3FormattingUtilities.getEscapedColumnName(paramIntrospectedColumn)) + " = case"));
              xmlElement1.addAttribute(new Attribute("suffix", "end,"));
              XmlElement xmlElement2 = new XmlElement("foreach");
              xmlElement2.getAttributes().add(0, new Attribute("collection", "list"));
              xmlElement2.getAttributes().add(1, new Attribute("item", "item"));
              xmlElement2.getAttributes().add(2, new Attribute("index", "index"));
              String str = "when " + paramString1 + " = " + paramString2 + " then " + b(paramIntrospectedColumn, false);
              TextElement textElement = new TextElement(str);
              xmlElement2.addElement((Element)textElement);
              xmlElement1.addElement(0, (Element)xmlElement2);
              return xmlElement1;
            }).forEachOrdered(xmlElement3::addElement);
        TextElement textElement1 = new TextElement("where " + str2 + " in");
        XmlElement xmlElement = new XmlElement("foreach");
        xmlElement.getAttributes().add(0, new Attribute("collection", "list"));
        xmlElement.getAttributes().add(1, new Attribute("item", "item"));
        xmlElement.getAttributes().add(1, new Attribute("open", "("));
        xmlElement.getAttributes().add(2, new Attribute("separator", ", "));
        xmlElement.getAttributes().add(1, new Attribute("close", ")"));
        xmlElement.addElement((Element)new TextElement(str1));
        xmlElement2.addElement((Element)textElement);
        xmlElement2.addElement((Element)xmlElement3);
        xmlElement2.addElement((Element)textElement1);
        xmlElement2.addElement((Element)xmlElement);
      } 
      xmlElement1.addElement((Element)xmlElement2);
    } 
    return super.sqlMapDocumentGenerated(paramDocument, paramIntrospectedTable);
  }
  
  public boolean clientGenerated(Interface paramInterface, TopLevelClass paramTopLevelClass, IntrospectedTable paramIntrospectedTable) {
    if (paramIntrospectedTable.hasPrimaryKeyColumns()) {
      FullyQualifiedJavaType fullyQualifiedJavaType = new FullyQualifiedJavaType(this.a.getShortName());
      fullyQualifiedJavaType.addTypeArgument(JavaElementGeneratorTools.a(paramIntrospectedTable));
      Method method = JavaElementGeneratorTools.a("updateBatch", JavaVisibility.DEFAULT, 

          
          FullyQualifiedJavaType.getIntInstance(), new Parameter[] { new Parameter(fullyQualifiedJavaType, "list", "@Param(\"list\")") });
      method.setReturnType(new FullyQualifiedJavaType("int"));
      paramInterface.addImportedType(this.a);
      FormatTools.a(paramInterface, method);
    } 
    return super.clientGenerated(paramInterface, paramTopLevelClass, paramIntrospectedTable);
  }
  
  private String a(IntrospectedColumn paramIntrospectedColumn, boolean paramBoolean) {
    StringBuilder stringBuilder = new StringBuilder();
    stringBuilder.append(paramIntrospectedColumn.getActualColumnName());
    stringBuilder.append(" = ");
    if (paramBoolean) {
      stringBuilder.append("#{");
    } else {
      stringBuilder.append("#{item.");
    } 
    stringBuilder.append(paramIntrospectedColumn.getJavaProperty());
    stringBuilder.append(",jdbcType=");
    stringBuilder.append(paramIntrospectedColumn.getJdbcTypeName());
    stringBuilder.append("}");
    return stringBuilder.toString();
  }
  
  private String b(IntrospectedColumn paramIntrospectedColumn, boolean paramBoolean) {
    if (paramBoolean)
      return MyBatis3FormattingUtilities.getParameterClause(paramIntrospectedColumn, null); 
    return MyBatis3FormattingUtilities.getParameterClause(paramIntrospectedColumn, "item.");
  }
}
